//Source file: C:\\GENERATE_JAVA\\generate_prod_cons\\stock.java


public class stock 
{
   private Integer taille;
   private Object [] st=new stock[taille];
   private Integer suivant;
   private Boolean estplein= false;
   private Boolean estvide = true;;
   
   public stock() 
   {
    
   }

	// retirer un produit du stock(dernier entre)
	public synchronized produit retirer()
	{
		while (true)
		{
			try
			{
				wait();

			}
			catch (InterruptedException ex)
			{
				System.out.println(ex.toString());
			}
			suivant--;
			if (suivant == 0)
			{
				estplein = false;
				notify();
				produit op = (produit)st[suivant];
				System.out.println("le produit suivant est retire");
				op.afficher();
				return (op);
			}
		}
	}
  
	// ajouter un produit au stock
   public synchronized void ajouter(produit pr) 
   {
	while (true)
		{
			try
			{
				wait();

			}
			catch (InterruptedException ex)
			{
				System.out.println(ex.toString());
			}
			st[suivant]=pr;
		   System.out.println("le produit suivant est ajoute");
		   pr.afficher();
		   suivant++;
			if (suivant == taille)
			{
				estplein = true;
			}
		       estvide = false;
		       notify();
				
			}
		}
    

   }
